var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import * as React from 'react';
import RcTree, { TreeNode as RcTreeNode } from 'rc-tree';
import classNames from 'classnames';
import useMeasure from 'react-use/lib/useMeasure';
import CheckBoxDemo from "../checkbox";
import Icon from "../icon";
import size from 'lodash/size';
import "./style/tree.css";
import { useCallback, useRef, useImperativeHandle } from 'react';
import dropIndicatorRender from "./dropIndicator";
var prefixCls = 'dmc-tree';
var Tree = /*#__PURE__*/React.forwardRef(function (props, treeRef) {
  var _a;

  var className = props.className,
      showIcon = props.showIcon,
      switcherIcon = props.switcherIcon,
      blockNode = props.blockNode,
      children = props.children,
      checkable = props.checkable,
      direction = props.direction,
      icon = props.icon,
      fullSelect = props.fullSelect,
      height = props.height,
      type = props.type,
      withoutSelectEffect = props.withoutSelectEffect,
      itemHeight = props.itemHeight,
      style = props.style,
      emptyContent = props.emptyContent,
      treeData = props.treeData,
      withoutHoverEffect = props.withoutHoverEffect,
      restProps = __rest(props, ["className", "showIcon", "switcherIcon", "blockNode", "children", "checkable", "direction", "icon", "fullSelect", "height", "type", "withoutSelectEffect", "itemHeight", "style", "emptyContent", "treeData", "withoutHoverEffect"]);

  var _b = useMeasure(),
      measureRefCallback = _b[0],
      eleHeight = _b[1].height;

  var wrapperRef = useRef(null);
  var rcTreeRef = useRef(null);
  var wrapperRefCallback = useCallback(function (node) {
    if (node) {
      measureRefCallback(node);
    }

    wrapperRef.current = node;
  }, [measureRefCallback]);
  var rcTreeRefCallback = useCallback(function (node) {
    rcTreeRef.current = node;
  }, []);

  var mixIcon = function mixIcon(props) {
    var _a;

    var checkboxDisabled = props.disabled || ((_a = props.data) === null || _a === void 0 ? void 0 : _a.disableCheckbox);
    var iconRender = typeof icon === 'function' ? icon(props) : icon;
    return _jsxs(_Fragment, {
      children: [checkable && _jsx(CheckBoxDemo, {
        checked: props.checked,
        indeterminate: props.halfChecked,
        disabled: checkboxDisabled
      }, void 0), iconRender]
    }, void 0);
  };

  var treeStyle = React.useMemo(function () {
    return itemHeight ? __assign(__assign({}, style), {
      lineHeight: itemHeight - 6 + "px"
    }) : style;
  }, [itemHeight, style]);
  var cls = classNames(className, (_a = {}, _a[prefixCls + "-icon-hide"] = !showIcon, _a[prefixCls + "-block-node"] = blockNode, _a[prefixCls + "-checkable"] = checkable, _a[prefixCls + "-rtl"] = direction === 'rtl', _a[prefixCls + "-full"] = fullSelect, _a[prefixCls + "-without-select-effect"] = withoutSelectEffect, _a[prefixCls + "-without-hover-effect"] = withoutHoverEffect, _a[prefixCls + "-" + type] = type, _a));
  useImperativeHandle(treeRef, function () {
    return {
      treeComponent: rcTreeRef.current,
      componentWrapper: wrapperRef.current
    };
  });
  return _jsx("div", __assign({
    className: prefixCls + "-wrapper",
    style: {
      height: height
    },
    ref: wrapperRefCallback
  }, {
    children: size(treeData) === 0 && emptyContent ? emptyContent : eleHeight && _jsx(RcTree, __assign({}, restProps, {
      style: treeStyle,
      ref: rcTreeRefCallback,
      treeData: treeData,
      height: eleHeight,
      prefixCls: prefixCls,
      className: cls,
      checkable: checkable,
      icon: mixIcon,
      itemHeight: itemHeight,
      dropIndicatorRender: dropIndicatorRender,
      switcherIcon: switcherIcon || function (nodeProps) {
        var isLeaf = nodeProps.isLeaf,
            expanded = nodeProps.expanded;
        var icons = ['arrow-right', 'arrow-down'];
        return !isLeaf ? _jsx(Icon, {
          icon: icons[Number(!!expanded)]
        }, void 0) : null;
      }
    }, {
      children: children
    }), void 0)
  }), void 0);
});
Tree.defaultProps = {
  checkable: false,
  showIcon: true,
  blockNode: false,
  virtual: true,
  fullSelect: false,
  withoutSelectEffect: false
};
var TreeMemo = /*#__PURE__*/React.memo(Tree);
TreeMemo.displayName = 'TreeMemo';
export { TreeMemo, RcTreeNode as TreeNode };
Tree.displayName = 'Tree';
export default Tree;

